<?
/**
 * Title : Recorded Game Mod Express-Edition
 * ------------------------------
 * Autor : Jose Rolando Mdos 
 *         @ http://wwww.t1poder.com.ar
 *         @ http://wwww.aocgroup.com.ar
 * Date : Sbado, 5/11/05 4:24 PM
 * Platform: phpBB 3 
 **/
 
if (!defined ('RECMOD_CLASS'))
{
define ('RECMOD_CLASS', TRUE);
define ('RATING_BASE', 1500);

/** Rutas **/
define ('PATH_TO_DATA', $phpbb_root_path . '/recmod/');
define ('PATH_TO_IMAGES' , 'images/aoc/');
define ('PATH_TO_FLAGS' , 'images/flags/');


/** Id No Flag, Bandera en Blanco, no se muestra **/
define ('NO_FLAG', 196);

/**
 * Data Provider 
 **/
class DataProvider
{
	var $arrayCivilizaciones;
	var $arrayFlags;
	var $arrayMapas;
	var $arrayTipos;
	
	/**
	 * Constructor
	 **/
	function DataProvider ()
	{
		$this->setCivilizacion ();
		$this->setFlags ();
		$this->setMapas ();
		$this->setTipos ();
	}
	function setCivilizacion()
	{
		$arrayCiv = array();
		require (PATH_TO_DATA . 'dataCivilizaciones.php');
		$this->arrayCivilizaciones = $arrayCiv;
	}
	function setFlags()
	{
		$arrayFlag = array();
		require (PATH_TO_DATA . 'dataFlag.php');
		$this->arrayFlags = $arrayFlag;
	}
	function setMapas()
	{
		$arrayMapas = array();
		require (PATH_TO_DATA . 'dataMapas.php');
		$this->arrayMapas = $arrayMapas;
	}
	function setTipos()
	{
		$arrayTipo = array();
		require (PATH_TO_DATA . 'dataTipos.php');
		$this->arrayTipos = $arrayTipo;
	}	
	function getCivilizacion ($iId)
	{
		if (array_key_exists ($iId, $this->arrayCivilizaciones))
		{
			return $this->arrayCivilizaciones[$iId];
		}
		else
		{
			return NULL;
		}
	}
	
	function getArrayCivilizaciones()
	{
		return $this->arrayCivilizaciones;
	}
	function getArrayFlags()
	{
		return $this->arrayFlags;
	}
	function getArrayMapas()
	{
		return $this->arrayMapas;
	}
	function getArrayTipos()
	{
		return $this->arrayTipos;
	}

	function getFlag ($iId)
	{
		if (array_key_exists ($iId, $this->arrayFlags))
		{
			return $this->arrayFlags[$iId];
		}
		else
		{
			return NULL;
		}
	}
	function getMapa ($iId)
	{
		if (array_key_exists ($iId, $this->arrayMapas))
		{
			return $this->arrayMapas[$iId];
		}
		else
		{
			return NULL;
		}
	}
	function getTipo ($iId)
	{
		if (array_key_exists ($iId, $this->arrayTipos))
		{
			return $this->arrayTipos[$iId];
		}
		else
		{
			return NULL;
		}
	}
} 
class RecordedGame
{

	var $objDb;
	var $objTemplate;
	var $arrayPlayers;
	
	function RecordedGame()
	{
	}
	
	function setSources (&$objDataProvider, &$objTemplate)
	{
		$this->objDb = &$objDataProvider;
		$this->objTemplate = &$objTemplate;
	}
	function showCreate()
	{
		$arrayCivilizaciones = $this->objDb->getArrayCivilizaciones();
		while( list ($iKey, $arrayValue ) = each ($arrayCivilizaciones))
		{
			$this->objTemplate->assign_block_vars ('civilizaciones', array (
				'VALUE' => $iKey,
				'NAME' => $arrayValue['NAME']
			));
		}
		$arrayMapas = $this->objDb->getArrayMapas();
		while( list ($iKey, $strValue ) = each ($arrayMapas))
		{
			$this->objTemplate->assign_block_vars ('mapas', array (
				'VALUE' => $iKey,
				'NAME' => $strValue
			));
		}
		$arrayTipos = $this->objDb->getArrayTipos();
		while( list ($iKey, $strValue ) = each ($arrayTipos))
		{
			$this->objTemplate->assign_block_vars ('tipos', array (
				'VALUE' => $iKey,
				'NAME' => $strValue
			));
		}
		$arrayFlags = $this->objDb->getArrayFlags();
		while( list ($iKey, $arrayValue ) = each ($arrayFlags))
		{
			$this->objTemplate->assign_block_vars ('flag', array (
				'VALUE' => $iKey,
				'NAME' => $arrayValue['NAME']
			));
		}
		for ($i = 1; $i <= 12; $i++)
		{
			$this->objTemplate->assign_block_vars ('rating', array (
				'VALUE' => $i,
				'NAME' => ( RATING_BASE + $i * 100 ) . '+'
			));
		}
		for ($i = 1; $i <= 4; $i++)
		{
			$this->objTemplate->assign_block_vars ('jugadores', array (
				'VALUE' => $i,
				'NAME' => $i . " vs " . $i
			));
		}
	}
	function showEdit()
	{
		$arrayMapas = $this->objDb->getArrayMapas();
		while( list ($iKey, $strValue ) = each ($arrayMapas))
		{
			$this->objTemplate->assign_block_vars ('MAPAS', array (
				'VALUE' => $iKey,
				'NAME' => $strValue,
				'SELECTED' => ( $this->mMapa == $iKey ) ? ( 'selected' ) : ( '' )
			));
		}
		$arrayTipos = $this->objDb->getArrayTipos();
		while( list ($iKey, $strValue ) = each ($arrayTipos))
		{
			$this->objTemplate->assign_block_vars ('TIPOS', array (
				'VALUE' => $iKey,
				'NAME' => $strValue,
				'SELECTED' => ( $this->mTipo == $iKey ) ? ( 'selected' ) : ( '' )
			));
		}
		for ($i = 1; $i <= 12; $i++)
		{
			$this->objTemplate->assign_block_vars ('RATING', array (
				'VALUE' => $i,
				'NAME' => ( RATING_BASE + $i * 100 ) . '+',
				'SELECTED' => ( $this->mRatingLevel == $i ) ? ( 'selected' ) : ( '' )
			));
		}
		for ($i = 1; $i <= 4; $i++)
		{
			$this->objTemplate->assign_block_vars ('JUGADORES', array (
				'VALUE' => $i,
				'NAME' => $i . " vs " . $i,
				'SELECTED' => ( $this->playersCantidad == $i ) ? ( 'selected' ) : ( '' )
			));
		}
		$this->objTemplate->assign_block_vars ('WINNER', array (
			'VALUE' => 0,
			'NAME' => "Watch and See",
			'SELECTED' => ( $this->mWinner == 0 ) ? ( "selected" ) : ( '' )
		));
		$this->objTemplate->assign_block_vars ('WINNER', array (
			'VALUE' => 1,
			'NAME' => "Team 1",
			'SELECTED' => ( $this->mWinner == 1 ) ? ( "selected" ) : ( '' )
		));
		$this->objTemplate->assign_block_vars ('WINNER', array (
			'VALUE' => 2,
			'NAME' => "Team 2",
			'SELECTED' => ( $this->mWinner == 2 ) ? ( "selected" ) : ( '' )
		));
		$duracion = split (":", $this->mDuracion);	
		$this->objTemplate->assign_vars ( array (
			'HORAS' => $duracion[0],
			'MINUTOS' => $duracion[1],
			'TEAMA' => $this->mTeam1,
			'TEAMB' => $this->mTeam2
		));
		for ($i = 0; $i < $this->playersCantidad; $i++)
		{
			if (  is_object ($this->arrayPlayers['B'][$i]))
			{
				$this->arrayPlayers['A'][$i]->printPlayerToEdit ($this->objDb, $this->objTemplate, $i + 1);
			}
			if (  is_object ($this->arrayPlayers['B'][$i]))
			{
				$this->arrayPlayers['B'][$i]->printPlayerToEdit ($this->objDb, $this->objTemplate, $i + 5);
			}
		}
		if ( $this->playersCantidad < 4 )
		{
			$arrayCivilizaciones = $this->objDb->getArrayCivilizaciones();
			$arrayFlags = $this->objDb->getArrayFlags();
			for ($i = $this->playersCantidad + 1; $i <= 4; $i++)
			{
				@reset ($arrayCivilizaciones);
				@reset ($arrayFlags);
				while( list ($iKey, $arrayValue ) = each ($arrayCivilizaciones))
				{
					$this->objTemplate->assign_block_vars ('CIVILIZACIONES' . $i , array (
						'VALUE' => $iKey,
						'NAME' => $arrayValue['NAME']
					));
				}
				while( list ($iKey, $arrayValue ) = each ($arrayFlags))
				{
					$this->objTemplate->assign_block_vars ('FLAG' . $i, array (
						'VALUE' => $iKey,
						'NAME' => $arrayValue['NAME']
					));
				}
				@reset ($arrayCivilizaciones);
				@reset ($arrayFlags);
				while( list ($iKey, $arrayValue ) = each ($arrayCivilizaciones))
				{
					$this->objTemplate->assign_block_vars ('CIVILIZACIONES' . ($i + 4) , array (
						'VALUE' => $iKey,
						'NAME' => $arrayValue['NAME']
					));
				}
				while( list ($iKey, $arrayValue ) = each ($arrayFlags))
				{
					$this->objTemplate->assign_block_vars ('FLAG' . ($i + 4), array (
						'VALUE' => $iKey,
						'NAME' => $arrayValue['NAME']
					));
				}
			}
		}		
	}
	function toArray()
	{
		$arrayInfo = array ();
		
		$template = &$this->objTemplate;
		$template->set_filenames( array (
			'recordgame_player' => 'recorded_game_players.html'
		));
		
		$template->destroy_block_vars ('p1');
		$template->destroy_block_vars ('p2');
		$template->assign_vars (array (
			'TEAM1' => $this->mTeam1,
			'TEAM2' => $this->mTeam2)
		);
		
		$arrayInfo = array (
			'MAPA_IMAGEN' => str_replace (" ", "_", strtolower($this->objDb->getMapa ($this->mMapa))) . ".gif",
			'MAPA' => $this->objDb->getMapa ($this->mMapa),
			'TIPO' => $this->objDb->getTipo ($this->mTipo),
			'DURACION' => $this->mDuracion,
			'WINNER' => ( $this->mWinner == 1 ) ? ( $this->mTeam1 )  : ( ( $this->mWinner == 2 ) ? ( $this->mTeam2 ) : ( "Watch and See" ) ),
			'RATING' => ( RATING_BASE + 100 * $this->mRatingLevel ),
			'JUGADORES' => ( $this->playersCantidad . " vs " . $this->playersCantidad )
		);

		for( $i = 0; $i < count ($this->arrayPlayers['A']); $i++)
		{
			if (  is_object ($this->arrayPlayers['A'][$i]))
			{
				$dataPlayer = $this->arrayPlayers['A'][$i]->toArray($this->objDb);
				$template->assign_block_vars ('p1', $dataPlayer);
			}
		}
		for( $i = 0; $i < count ($this->arrayPlayers['B']); $i++)
		{
			if ( is_object ($this->arrayPlayers['B'][$i]))
			{
				$dataPlayer = $this->arrayPlayers['B'][$i]->toArray($this->objDb);
				$template->assign_block_vars ('p2', $dataPlayer);
			}
		}
		$arrayInfo['PLAYERS'] = $template->assign_display ('recordgame_player', '', TRUE);
		$arrayInfo['NFO'] = 'RecordedGame Mod @ <a href="http://www.aoc-games.com">AoC - Games</a>';
		return $arrayInfo;
	}
	function toStringAsTopic ($post_id, $class, $onlyTg)
	{
		if ($onlyTg && $this->playersCantidad == 1)
		{
			return;
		}
		
		$template = &$this->objTemplate;
		
		$template->destroy_block_vars ('single');
		$template->destroy_block_vars ('tg');
		$template->destroy_block_vars ('team1');
		$template->destroy_block_vars ('team2');
		$template->destroy_block_vars ('team3');
		$template->destroy_block_vars ('team4');
		
		$template->assign_vars (array (
			'MAPA' => $this->objDb->getMapa ($this->mMapa),
			'TIPO' => $this->objDb->getTipo ($this->mTipo),
			'DURACION' => $this->mDuracion,
			'TEAM1' => $this->mTeam1,
			'POST_ID' => $post_id,
			'TEAM2' => $this->mTeam2,
			'RATING' => ( RATING_BASE + 100 * $this->mRatingLevel ),
			'JUGADORES' => ( $this->playersCantidad . " vs " . $this->playersCantidad )
		));
		$template->set_filenames ( array (
			'topic' => "recorded_game_topics.html"
		));
		if ($this->playersCantidad == 1 )
		{
			$template->assign_block_vars ('single', array());
		}
		else
		{
			$var = ($onlyTg) ? 'tg' : 'team' . $this->playersCantidad;
			$template->assign_block_vars ($var, array());
		}
		for ($i = 0; $i < 4; $i++)
		{
			$template->assign_vars (array (
				'FLAG_A_' . ($i + 1) => '',
				'PLAYER_A_' . ($i + 1) => '')
			);
			$template->assign_vars (array (
				'FLAG_B_' . ($i + 1) => '',
				'PLAYER_B_' . ($i + 1) => '')
			);
		}
		for( $i = 0; $i < count ($this->arrayPlayers['A']); $i++)
		{
			if (  is_object ($this->arrayPlayers['A'][$i]))
			{
				$dataPlayer = $this->arrayPlayers['A'][$i]->toArrayAsSingle($this->objDb, '_A_' . ($i + 1));
				$template->assign_vars ($dataPlayer);
			}
		}
		for( $i = 0; $i < count ($this->arrayPlayers['B']); $i++)
		{
			if ( is_object ($this->arrayPlayers['B'][$i]))
			{
				$dataPlayer = $this->arrayPlayers['B'][$i]->toArrayAsSingle($this->objDb, '_B_' . ($i + 1));
				$template->assign_vars ($dataPlayer);
			}
		}
		
		$this->objTemplate->assign_block_vars ('recgame', array (
			'CONTENT' => $template->assign_display ('topic', '', TRUE),
			'CLASS' => $class
		));
	}
	function Create($iMapa, $iTipo, $strDuracion, $iWinner, $iRatingLevel, $playersCantidad, $strTeam1, $strTeam2, $arrayPlayersInfo)
	{
		$this->mMapa = intval ($iMapa);
		$this->mTipo = intval ($iTipo);
		$this->mDuracion = trim ($strDuracion);
		$this->mWinner = intval ($iWinner);
		$this->mRatingLevel = intval ($iRatingLevel);
		$this->mTeam1 = trim ($strTeam1);
		$this->mTeam2 = trim ($strTeam2);
		$this->playersCantidad = intval ($playersCantidad);
		for( $i = 0; $i < $this->playersCantidad; $i++)
		{
			$arrayPlayersInfo['playerNickA'][$i] = trim ($arrayPlayersInfo['playerNickA'][$i]);
			if ($arrayPlayersInfo['playerNickA'][$i] != "")
			{
				$this->arrayPlayers['A'][] = new Player($arrayPlayersInfo['playerNickA'][$i], $arrayPlayersInfo['playerCivA'][$i], 
					$arrayPlayersInfo['playerFlagA'][$i]);
			}
			$arrayPlayersInfo['playerNickB'][$i] = trim ($arrayPlayersInfo['playerNickB'][$i]);
			if ($arrayPlayersInfo['playerNickB'][$i] != "")
			{
				$this->arrayPlayers['B'][] = new Player($arrayPlayersInfo['playerNickB'][$i], $arrayPlayersInfo['playerCivB'][$i], 
					$arrayPlayersInfo['playerFlagB'][$i]);
			}
		}
	}
}

class Player
{
	var $mNick;
	var $mIdFlag;
	var $mIdCivilizacion;

	function toArray ($objDb)
	{
		$arrayReturn = array ();
		$arrayCivilizacion = $objDb->getCivilizacion ($this->mIdCivilizacion);
		if ($this->mIdFlag != NO_FLAG)
		{
			$arrayFlag = $objDb->getFlag ($this->mIdFlag);
			$arrayReturn['FLAG'] = '<img src="' . PATH_TO_FLAGS . $arrayFlag['Image'] . '" title="' . $arrayFlag['NAME'] . '" height="12" width="18" border="3" />';
		}
		$arrayReturn['CIVILIZACION'] = $arrayCivilizacion['NAME'];
		$arrayReturn['IMG'] = '<img src="' . PATH_TO_IMAGES . $arrayCivilizacion['Image'] . '" title="' . $arrayCivilizacion['NAME'] . '">';
		$arrayReturn['NICK'] = $this->mNick;
		return $arrayReturn;
	}
	function toArrayAsSingle ($objDb, $index)
	{
		$arrayReturn = array ();
		$arrayReturn['PLAYER' . $index] = $this->mNick;
		if ($this->mIdFlag != NO_FLAG)
		{
			$arrayFlag = $objDb->getFlag ($this->mIdFlag);
			$arrayReturn['FLAG' . $index] = '<img src="' . PATH_TO_FLAGS . $arrayFlag['Image'] . '" title="' . $arrayFlag['NAME'] . '" height="12" width="18" border="0" align="texttop" />';
		}
		return $arrayReturn;
	}
	function Player ($strNick, $iIdCivilizacion, $iIdFlag)
	{
		$this->mNick = $strNick;
		$this->mIdFlag = intval ($iIdFlag);
		$this->mIdCivilizacion = intval ($iIdCivilizacion);
	}
	function printPlayerToEdit ($objDb, &$template, $index)
	{
		$arrayFlags = $objDb->getArrayFlags();
		while( list ($iKey, $arrayValue ) = each ($arrayFlags))
		{
			$template->assign_block_vars ('FLAG' . $index, array (
				'VALUE' => $iKey,
				'NAME' => $arrayValue['NAME'],
				'SELECTED' => ( $this->mIdFlag == $iKey ) ? ( 'selected' ) : ( '' )
			));
		}
		$arrayCivilizaciones = $objDb->getArrayCivilizaciones();
		while( list ($iKey, $arrayValue ) = each ($arrayCivilizaciones))
		{
			$template->assign_block_vars ('CIVILIZACIONES' . $index, array (
				'VALUE' => $iKey,
				'NAME' => $arrayValue['NAME'],
				'SELECTED' => ( $this->mIdCivilizacion == $iKey ) ? ( 'selected' ) : ( '' )
			));
		}
		$template->assign_var ('PLAYER' . $index, $this->mNick);
	}
}
}
?>